//i2c.c

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <linux/i2c-dev.h>
#include <fcntl.h>
#include <string.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <time.h>
//
#include "i2c.h"

int		i2cHandle;
u_int8_t	i2c_txBuffer[i2cBUFFER_LENGTH];
u_int8_t	i2c_rxBuffer[i2cBUFFER_LENGTH];

//открытие устройства I2C
int	i2c_OPEN(u_int8_t address)
{
	int res;
	i2cHandle = open(_i2cBus, O_RDWR);
	if(i2cHandle < 0)
	{
		#if(_dbg > 0)
			printf("------ ERROR OPEN handle : %i\n", i2cHandle);
		#endif
		return -1;
	}
	res = ioctl(i2cHandle, I2C_SLAVE, address);
	if(res < 0)
	{
		#if(_dbg > 0)
			printf("------ ERROR ioctl OPEN handle : %i  ---ioctl %i\n", i2cHandle, res);
		#endif
		return -2;
	}
	#if(_dbg > 0)
		printf("------ OPEN handle : %i  ---ioctl %i\n", i2cHandle, res);
	#endif
	return 0;
}

//запись в устройство I2C
int	i2c_WRIETE(u_int8_t baddr, u_int8_t * bdata, u_int8_t bsize)
{
	int	res;
	i2c_txBuffer[0]	= baddr & _i2c_WR;
	memcpy(&i2c_txBuffer[1], bdata, bsize);
	res = write(i2cHandle, &i2c_txBuffer[0], bsize + 1);
	if(res < 0)
	{
		#if(_dbg > 0)
			printf("------error SEND sz: %i\n",res);
		#endif
		return -3;
	}
	#if(_dbg > 0)
		printf("------ SEND sz: %i\n",res);
	#endif
	return 0;
}

//чтение устройства I2C
int	i2c_READ(u_int8_t baddr, u_int8_t * bdata, u_int8_t bsize)
{
	int		res;
	u_int8_t	sbaddr	= baddr | _i2c_RD;
	res = write(i2cHandle, &sbaddr, 1);
	if(res < 0)
	{
		#if(_dbg > 0)
			printf("------error RD: %i\n",res);
		#endif
		return -4;
	}
	res = read(i2cHandle, &i2c_rxBuffer[0], 2);
	if(res < 0)
	{
		#if(_dbg > 0)
			printf("------error RECEIVE: %i\n",res);
		#endif
		return -5;
	}
	#if(_dbg > 0)
		printf("------RECEIVE: %i\n",res);
	#endif
	memcpy(bdata, &i2c_rxBuffer[0], bsize);
	return 0;
}

//закрытие устройства I2C
int	i2c_CLOSE(void)
{
	close(i2cHandle);
	//
	return 0;
}
