//main.c


#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <semaphore.h>
#include <time.h>
#include "mb12xx.h"
#include "main.h"

#define _slave_addr	0x70

sem_t 				*sem;
GDATA1 				*addr;
int 				shm;
uint64_t			timeSonar;
//
SENS_RADIUS			radius;

int main(int argc, char* argv[])
{
	//
	int		dist;
	char		gd;
	int 		scnt	= 1;
	char		dbg	= 1;
	char		fshm	= 0;					
	//
	if(argc < 2)
	{
		printf("MB1242 - Testing... (use \"--help\" for info in new starting)\n");
		printf("Input mode for 5V:\n");
		printf("1 = diagremm A\n");
		printf("2 = diagremm B\n");
		printf("3 = diagremm C\n");
		printf("4 = diagremm D\n");
		printf("?");
		gd = getchar();
		switch(gd)
		{
			case '1':
				radius.type_diagramm = _type_diagramm_MB1242_A50;
				break;
			case '2':
				radius.type_diagramm = _type_diagramm_MB1242_B50;
				break;
			case '3':
				radius.type_diagramm = _type_diagramm_MB1242_C50;
				break;
			case '4':
				radius.type_diagramm = _type_diagramm_MB1242_D50;
				break;
			default:
				radius.type_diagramm = _type_diagramm_MB1242_D50;
				break;
		}
	}
	else
	{
		while(scnt < argc)
		{
			if(strcmp(argv[scnt], "--help") == 0)
			{
				printf(_help_);
				return 0;
			}
			//дата и версия
	                if(strcmp(argv[scnt], "--version") == 0)
			{
	                        printf("Дата: ");
				printf(_date);
				printf("  Весия: ");
				printf(_version);
				printf("\n");
	                        return 0;
	                }
			if(strcmp(argv[scnt], "--start") == 0)
			{
				scnt++;
				if(scnt > argc)
					radius.type_diagramm = _type_diagramm_MB1242_D50;
				else
				{
					if(strcmp(argv[scnt], "MB1242_A50"))
						radius.type_diagramm = _type_diagramm_MB1242_A50;
					else if(strcmp(argv[scnt], "MB1242_B50"))
						radius.type_diagramm = _type_diagramm_MB1242_B50;
					else if(strcmp(argv[scnt], "MB1242_C50"))
						radius.type_diagramm = _type_diagramm_MB1242_C50;
					else if(strcmp(argv[scnt], "MB1242_D50"))
						radius.type_diagramm = _type_diagramm_MB1242_D50;
					else
						radius.type_diagramm = _type_diagramm_MB1242_D50;
				}
				dbg 	= 0;
				fshm	= 1;
				break;
			}
			else
			{
				printf("parametr: \"%s\" - unknown!\n", argv[argc]);
				return 1;
			}
			scnt++;
		}
	}
	//
	if(fshm > 0)
	{
		//память - создание
		if ( (shm = shm_open(gdatSHARED_MEMORY_OBJECT_NAME, O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
		{
       			perror("shm_open");
	        	return 1;
    		}
		if ( ftruncate(shm, gdatSHARED_MEMORY_OBJECT_SIZE+1) == -1 ) 
		{
			perror("ftruncate");
			return 2;
	        }
		//семафор - создание
		if ( (sem = sem_open(gdatSEMAPHORE_NAME, O_CREAT, 0777, 0)) == SEM_FAILED ) 
		{
			perror("sem_open");
			return 3;
		}
		sem_post(sem);
	}
	//
	while(1)
	{
		timeSonar	= time(NULL);
		dist		= mb1242read_sensorR(_slave_addr, &radius);
		if(dbg > 0)
		{
			if(dist < 0)
				printf("---------------- ERROR work of MB1242 error code: %i\n", dist);
			else
				printf("-- diagramm %i   distance %i radius %i ------ \"Cnrl+c\" for exit \n", radius.type_diagramm, dist, radius.radius);
		}
		//
		if(fshm > 0)
		{
			sem_wait(sem);
			//
			if ( (addr = mmap(0, gdatSHARED_MEMORY_OBJECT_SIZE+1, PROT_WRITE|PROT_READ, MAP_SHARED, shm, 0)) == (GDATA1*)-1 )
			{
        			perror("mmap");
        			break;
    			}
			//
			addr->timeSonar		= timeSonar;
			addr->sonardistance	= dist;
			addr->sonarradius	= radius.radius;
			//
			sem_post(sem);
		}
		//
		usleep(_sonarsleep);
	}

	return 0;
}

